// Code generated by go-swagger; DO NOT EDIT.

package images

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the generate command

import (
	"net/http"

	"github.com/go-openapi/runtime/middleware"
)

// ImageStatusHandlerFunc turns a function with the right signature into a image status handler
type ImageStatusHandlerFunc func(ImageStatusParams) middleware.Responder

// Handle executing the request and returning a response
func (fn ImageStatusHandlerFunc) Handle(params ImageStatusParams) middleware.Responder {
	return fn(params)
}

// ImageStatusHandler interface for that can handle valid image status params
type ImageStatusHandler interface {
	Handle(ImageStatusParams) middleware.Responder
}

// NewImageStatus creates a new http.Handler for the image status operation
func NewImageStatus(ctx *middleware.Context, handler ImageStatusHandler) *ImageStatus {
	return &ImageStatus{Context: ctx, Handler: handler}
}

/*ImageStatus swagger:route GET /api/images/{id} Images imageStatus

Get image status

*/
type ImageStatus struct {
	Context *middleware.Context
	Handler ImageStatusHandler
}

func (o *ImageStatus) ServeHTTP(rw http.ResponseWriter, r *http.Request) {
	route, rCtx, _ := o.Context.RouteInfo(r)
	if rCtx != nil {
		r = rCtx
	}
	var Params = NewImageStatusParams()

	if err := o.Context.BindValidRequest(r, route, &Params); err != nil { // bind params
		o.Context.Respond(rw, r, route.Produces, route, err)
		return
	}

	res := o.Handler.Handle(Params) // actually handle the request

	o.Context.Respond(rw, r, route.Produces, route, res)

}
